
// Rauhigkeit des Gebirgezugs
float H = 1.25;
FloatList values;
int rseed = 11;
float ySkalierung = 250;

//////////////////////////////////////////////////////


void setup() {
  size(900, 300);
  background(255);
  values = new FloatList();
  initValues();
  textSize(16);
  // frameRate(3);
}

//////////////////////////////////////////////////////

void initValues() {
  randomSeed(rseed);
  values.clear();
  values.append(0.0f);
  values.append(0.0f);
}

//////////////////////////////////////////////////////

void subdivideValues() {

  FloatList tmp = new FloatList();

  // Relation der zufälligen Anhebung zur Länge
  // des Segments
  float amplitude = pow(1f/(values.size()-1), H);
  
  for (int i=0; i<values.size()-1; i++) {
    float v0 = values.get(i);
    float v1 = values.get(i+1);
    tmp.append(v0);
    tmp.append((v1+v0)/2 + random(-1f, 1f)*amplitude);
  }  
  tmp.append(values.get(values.size()-1));
  values = tmp;
}

//////////////////////////////////////////////////////

void draw() {
  background(255);
  noFill();
  beginShape();
  float len = width-60;
  for (int i=0; i<values.size(); i++) {
    float x = len*(i)/(values.size()-1);
    float y = ySkalierung*values.get(i);
    vertex(30+x, height/2-y);
  }
  endShape();
  
  String s = (values.size()-1) + " Strecken, Rauigkeit: " + H;
  fill(0);
  text(s,10,20);
  if (values.size()<300) subdivideValues();
} 

//////////////////////////////////////////////////////

void keyPressed() {
  if (key == '+') H = min(5, H+0.1);
  if (key == '-') H = max(0, H-0.1);
  if (key == 'r') rseed = (int)random(1,65535);
  initValues();
}